pipeline {
  agent any
  options {
    buildDiscarder(logRotator(numToKeepStr: '5'))
  }
  environment {
    DOCKERHUB_CREDENTIALS = credentials('timursyainov-dockerhub')
    PROJECT_ID = 'prod-338011'
    CLUSTER_NAME = 'k8s-apps'
    LOCATION = 'europe-west4-a'
    CREDENTIALS_ID = 'prod-338011'
  }
  stages {
    stage('Build') {
      steps {
        sh 'docker build -t timursyainov/flatris:latest .'
      }
    }
    stage('Login') {
      steps {
        sh 'echo $DOCKERHUB_CREDENTIALS_PSW | docker login -u $DOCKERHUB_CREDENTIALS_USR -p $DOCKERHUB_CREDENTIALS_PSW'
      }
    }
    stage('Push') {
      steps {
        sh 'docker push timursyainov/flatris:latest'
      }
    }
	stage('Deploy to GKE') {
        steps{
            sh "sed -i 's/hello:latest/hello:${env.BUILD_ID}/g' deployscript.yaml"
                step([$class: 'KubernetesEngineBuilder', projectId: env.PROJECT_ID, clusterName: env.CLUSTER_NAME, location: env.LOCATION, manifestPattern: 'deployscript.yaml', credentialsId: env.CREDENTIALS_ID, verifyDeployments: true])
            }
        }
  }
}